-- J. Craig Gilbert
-- bitnaut@soulsteam.com
-- 06-19-2001: Removed some clutter (unused routines)

include wildcard.e
include get.e


------------------------------------------------------------------------------
global function trim(sequence s, atom trimchar)
-- trim all instances of given character from both ends of sequence s
integer len, pos

   len = length(s)
   if len then
      pos = 1
      while s[pos] = trimchar do
         if pos = len then
            exit
         end if
         pos = pos + 1
      end while

      s = s[pos..len]
      len = length(s)
      pos = len
      while s[pos] = trimchar do
         if pos = 1 then
            exit
         end if
         pos = pos - 1
      end while
      s = s[1..pos]
      if length(s) = 1 then
         if s[1] = trimchar then
            s = ""
         end if
      end if
   end if

   return s
end function
------------------------------------------------------------------------------
global function str_to_int(sequence s)
-- translate a string of numerical characters into an integer
-- ignore leading space
-- stops translating when it hits a non-digit and returns whatever it got
-- by that point
object num
integer len
sequence numstr

   s = trim(s,' ')
   len = length(s)
   numstr = "" 
   for x = 1 to len do
      if s[x] >= '0' and s[x] <= '9' then
         numstr = numstr & s[x]
      else
         exit
      end if
   end for

   num = value(numstr)
   if num[1] = GET_SUCCESS then
      return num[2]
   else
      return 0
   end if
end function
------------------------------------------------------------------------------

