puts(1,"Loading...")
include machine.e
include mem.e
include get.e
include rwd.e

--ECB MODE ONLY!

sequence message,password, filename, keyfile
object inkey
integer roundnum, id,id2,len

password={}

type even(integer x)
return floor(x/2)=x/2
end type

type odd(integer x)
return floor(x/2)!=x/2
end type

function reverse(sequence data)
sequence temp
temp={}
for i=length(data) to 1 by -1 do
temp&=data[i]
end for
return temp
end function

function unbind(atom data)
atom a,b
sequence bintemp
bintemp=int_to_bits(data,16)
a=bits_to_int(bintemp[1..8])
b=bits_to_int(bintemp[9..16])
bintemp={}
return {a,b}
end function

function bind(sequence ab)
atom out
sequence bintemp1,bintemp2,bintemp3
bintemp1=int_to_bits(ab[1],8)
bintemp2=int_to_bits(ab[2],8)
bintemp3=bintemp1&bintemp2
out=bits_to_int(bintemp3)
bintemp1={}
bintemp2={}
bintemp3={}
return out
end function

function swap(atom data)
sequence temp
atom x
temp=unbind(data)
temp=reverse(temp)
x=bind(temp)
return x
end function

function key_func(atom data, atom key)
data=bits_to_int(reverse(int_to_bits(data,8))) --Invert bits
data=xor_bits(data,key)
data=bits_to_int(reverse(int_to_bits(data,8))) --Invert bits
key=bits_to_int(reverse(int_to_bits(key,8))) --Invert bits
data=xor_bits(data,key)
key=bits_to_int(reverse(int_to_bits(key,8))) --Invert bits
data=xor_bits(data,key)
data=bits_to_int(reverse(int_to_bits(data,8))) --Invert bits
key=bits_to_int(reverse(int_to_bits(key,8))) --Invert bits
data=xor_bits(data,key)
return data
end function

function feistel(atom data,atom key)
sequence x
atom y
x=unbind(data)
x[2]=xor_bits(key_func(x[1],key),x[2])
x=reverse(x)
x[2]=xor_bits(key_func(x[1],key),x[2])
x=reverse(x)
y=bind(x)
return y
end function

function bindseq(sequence data)
sequence tempdat
tempdat={}
if odd(length(data)) then
data&=0
end if
for i=1 to length(data)-1 by 2 do
tempdat&=bind({data[i],data[i+1]})
end for
return tempdat
end function

function unbindseq(sequence data)
sequence tempdat
tempdat={}
for i=1 to length(data) do
tempdat&=unbind(data[i])
end for
if even(length(tempdat)) and tempdat[length(tempdat)]=0 then
tempdat=tempdat[1..length(tempdat)-1]
end if
return tempdat
end function

function cipher(sequence data,sequence key,integer rounds,integer mode)
if mode=1 then
end if
if mode=2 then
key=reverse(key)
end if
data=bindseq(data)
while length(key)<length(data) do
key&=key
end while
for i=1 to length(data) do
for j=1 to rounds do
data[i]=feistel(data[i],key[i])
end for
data[i]=swap(data[i])
end for
data=unbindseq(data)
return data
end function

function get_file(integer fn)
sequence data
integer loc,x
loc=0
data={}
for i=1 to file_length(fn) do
x=seek(fn,loc)
data&=getc(fn)
loc+=1
end for
return data
end function

procedure set_file(integer fn, sequence data)
for i=1 to length(data) do
puts(fn,data[i])
end for
end procedure

clear_screen()
puts(1,"Feistel Style Cipher: model 1\n")
puts(1,"By: Flaming Rain Software\n\n")
puts(1,"INFO: Encrypts data 16-bits at a time using the feistel key system\nOnly ECB (Electronic Code Book) mode is used right now\n\n")
puts(1,"1) Encrypt\n2) Decrypt\n3) Test")

inkey=wait_key()
clear_screen()

if inkey='1' then
inkey=0
puts(1,"Enter the name of the file you wish to encrypt:\n")
filename=read_key(0,2)
id=open(filename,"rb")
message=get_file(id)
close(id)
clear_screen()
puts(1,"Choose an encryption key option:\n")
puts(1,"1) User-defined password\n2) Random key made by system\n3) Use a file as the key\n\n")
inkey=wait_key()
clear_screen()
if inkey='1' then
inkey=0
puts(1,"Enter your password:\n")
password=read_key(0,2)
end if

if inkey='2' then
inkey=0
puts(1,"Enter key length in bytes:\n")
inkey=get(0)
len=inkey[2]
inkey=0
for i=1 to len do
password&=rand(256)-1
end for
puts(1,"Would you like to store this key in a file?\n")
puts(1,"1) Yes\n2) No\n")
inkey=wait_key()
clear_screen()
if inkey='1' then
inkey=0
puts(1,"Enter the name of the file you wish to store the key in:\n")
keyfile=read_key(0,2)
id2=open(keyfile,"wb")
set_file(id2,password)
close(id2)
keyfile={}
end if
if inkey='2' then
inkey=0
end if
end if

if inkey='3' then
inkey=0
clear_screen()
puts(1,"Enter the name of the file you wish to use as the key:\n")
keyfile=read_key(0,2)
id2=open(keyfile,"rb")
password=get_file(id2)
close(id2)
keyfile={}
end if

clear_screen()
puts(1,"Encrypting...")
message=cipher(message,password,16,1)
id=open(filename,"wb")
set_file(id,message)
clear_screen()
puts(1,"Complete")
end if

if inkey='2' then
inkey=0
puts(1,"Enter the name of the file you wish to decrypt:\n")
filename=read_key(0,2)
id=open(filename,"rb")
message=get_file(id)
close(id)
clear_screen()
puts(1,"Select key method:\n")
puts(1,"1) Password\n2) Key is in file\n")
inkey=wait_key()
if inkey='1' then
inkey=0
clear_screen()
puts(1,"Enter your password\n")
password=read_key(0,2)
end if
if inkey='2' then
inkey=0
puts(1,"Enter the name of the file the key is stored in.\n")
keyfile=read_key(0,2)
id2=open(keyfile,"rb")
password=get_file(id2)
close(id2)
clear_screen()
puts(1,"Key data retrieved, destroy key file?\n")
puts(1,"1) Yes\n2) No")
inkey=wait_key()
if inkey='1' then
inkey=0
system("del "&keyfile,2)
end if
if inkey='2' then
inkey=0
end if
end if
clear_screen()
puts(1,"Decrypting...")
message=cipher(message,password,16,2)
id=open(filename,"wb")
set_file(id,message)
close(id)
clear_screen()
puts(1,"Complete.")
end if

if inkey='3' then
inkey=0
clear_screen()
puts(1,"Enter a message:\n")
message=read_key(0,2)
puts(1,"\nEnter a password:\n")
password=read_key(0,4)
puts(1,"\nEnter number of rounds:\n")
inkey=get(0)
roundnum=inkey[2]
clear_screen()
puts(1,message&"\n")
print(1,message)
message=cipher(message,password,roundnum,1)
puts(1,"\n\n"&message&"\n")
print(1,message)
message=cipher(message,password,roundnum,2)
puts(1,"\n\n"&message&"\n")
print(1,message)
end if