include machine.e
include file.e
include get.e

without warning

global constant LEFT=-1
global constant RIGHT=1
global constant POINT=1
global constant XAXIS=2
global constant YAXIS=3
global constant ZAXIS=4

global procedure print_memdata(atom start, atom Xend)
for i=start to Xend do
printf(1,"%d: %d\n",{i,peek(i)})
end for
end procedure

global procedure clear_mem(atom start,atom Xend)
for i=start to Xend do
poke(i,0)
end for
end procedure

global procedure poke_word(atom location, atom value, integer style)
sequence value1,value2,valuex
atom avalue1,avalue2
if style=1 then
valuex=int_to_bits(value,16)
value1=valuex[1..8]
value2=valuex[9..16]
avalue1=bits_to_int(value1)
avalue2=bits_to_int(value2)
poke(location,avalue1)
poke(location+1,avalue2)
end if
end procedure

global procedure poke_dword(atom location, atom value,integer style)
sequence value1,value2,value3,value4,valuex
atom avalue1,avalue2,avalue3,avalue4
if style=1 then
valuex=int_to_bits(value,32)
value1=valuex[1..8]
value2=valuex[9..16]
value3=valuex[17..24]
value4=valuex[25..32]
avalue1=bits_to_int(value1)
avalue2=bits_to_int(value2)
avalue3=bits_to_int(value3)
avalue4=bits_to_int(value4)
poke(location,avalue1)
poke(location+1,avalue2)
poke(location+2,avalue3)
poke(location+3,avalue4)
end if
end procedure

global function peek_word(atom location, atom style)
sequence value1,value2,valuex
atom avalue1,avalue2,avaluex
if style=1 then
avalue1=peek(location)
avalue2=peek(location+1)
value1=int_to_bits(avalue1,8)
value2=int_to_bits(avalue2,8)
valuex=value1&value2
avaluex=bits_to_int(valuex)
end if
return avaluex
end function

global function peek_dword(atom location, atom style)
sequence value1,value2,value3,value4,valuex
atom avalue1,avalue2,avalue3,avalue4,avaluex
if style=1 then
avalue1=peek(location)
avalue2=peek(location+1)
avalue3=peek(location+2)
avalue4=peek(location+3)
value1=int_to_bits(avalue1,8)
value2=int_to_bits(avalue2,8)
value3=int_to_bits(avalue3,8)
value4=int_to_bits(avalue4,8)
valuex=value1&value2&value3&value4
avaluex=bits_to_int(valuex)
end if
return avaluex
end function

global function file_length(integer fn)
atom sbp,ebp,n,filelength
n=seek(fn,0)
sbp=where(fn)
n=seek(fn,-1)
ebp=where(fn)
n=seek(fn,0)
filelength=ebp-sbp
return filelength
end function

global function file_to_mem(integer fn,integer cont,integer breakpoint)
atom filelen,memleft,go,x,cbp
sequence handles
handles={}
go=1
cbp=0
filelen=file_length(fn)
memleft=filelen
--Allocate conitiguous block for file if desired
if cont=1 then
handles&=allocate(filelen)
end if

--Allocate in non-contiguous blocks defined by breakpoint
if cont=0 then
while go=1 do
if memleft<breakpoint then
handles&=allocate(breakpoint)
memleft-=memleft
end if
if memleft>=breakpoint then
handles&=allocate(breakpoint)
memleft-=breakpoint
end if
if memleft=0 then
go=0
end if
end while
end if
for i=1 to length(handles) do
clear_mem(handles[i],handles[i]+breakpoint)
end for
--End allocation section

--Load file to memory
if breakpoint=-1 then
breakpoint=filelen
end if
x=seek(fn,0)
for i=1 to length(handles) do
for j=0 to breakpoint-1 do
x=seek(fn,cbp)
poke(handles[i]+j,getc(fn))
cbp+=1
end for
end for
--End load section

--Change 255 to 0
for i=0 to breakpoint-1 do
if peek(handles[length(handles)]+i)=255 then
poke(handles[length(handles)]+i,0)
end if
end for
return handles
end function

global procedure mem_to_file(integer fn,sequence handles,integer breakpoint, integer start, integer param)
atom X
X=seek(fn,start)
for i=1 to length(handles) do
for j=0 to breakpoint-1 do
if param=-1 then
if peek(handles[i]+j)!=0 and peek(handles[i]+j)!=255 then
puts(fn,peek(handles[i]+j))
end if
else if param=1 then
puts(fn,peek(handles[i]+j))
end if
end if
end for
end for
end procedure

global procedure free_file_mem(sequence handles)
for i=1 to length(handles) do
free(handles[i])
end for
end procedure

global function get_memdata(atom start,atom Xend)
object data
data={}
for i=start to Xend do
data&=peek(i)
end for
return data
end function

global procedure set_memdata(atom start,sequence data)
for i=1 to length(data) do
poke(start+(i-1),data[i])
end for
end procedure

global function find_in_block(integer data, atom start, atom Xend)
integer q
q=-1
for i=start to Xend do
if peek(i)=data then
q=i-start
exit
end if
end for
return q
end function

global procedure shift_r(atom start, atom Xend)
integer temp
temp=peek(Xend)
for i=Xend-1 to start by -1 do
poke(i+1,peek(i))
end for
poke(start,temp)
end procedure

global procedure shift_l(atom start,atom Xend)
integer temp
temp=peek(start)
for i=start+1 to Xend do
poke(i-1,peek(i))
end for
poke(Xend,temp)
end procedure

global procedure swap_blocks(sequence adda, sequence addb)
integer lengtha, lengthb
sequence tempb
atom temp
lengtha=adda[2]-adda[1]
lengthb=addb[2]-addb[1]
temp=allocate(lengthb)
tempb=get_memdata(addb[1],addb[2])
set_memdata(addb[1],get_memdata(adda[1],adda[2]))
set_memdata(adda[1],tempb)
free(temp)
end procedure

global procedure xor_blocks(sequence adda,sequence addb)
sequence bintemp1,bintemp2,bintemp3
integer newbyte
for i=0 to (adda[2]-adda[1]) do
bintemp1=int_to_bits(peek(adda[1]+i),8)
bintemp2=int_to_bits(peek(addb[1]+i),8)
bintemp3=xor_bits(bintemp1,bintemp2)
newbyte=bits_to_int(bintemp3)
poke(adda[1]+i,newbyte)
end for
end procedure

global procedure reverse_block(atom start, atom Xend)
atom tempblock
integer temploc, len
temploc=0
len=Xend-start
tempblock=allocate(len)
for i=Xend to start by -1 do
poke(tempblock+temploc,peek(i))
temploc+=1
end for
swap_blocks({start,Xend},{tempblock,tempblock+(Xend-start)})
clear_mem(tempblock,tempblock+(Xend-start))
free(tempblock)
end procedure

global function define_3d_matrix(integer rows, integer columns, integer panels)
atom x
sequence handle
x=allocate(rows*columns*panels)
handle={}
handle&=x
handle&=rows
handle&=columns
handle&=panels
return handle
end function

global function define_2d_matrix(integer rows, integer columns)
atom x
sequence handle
x=allocate(rows*columns)
handle={}
handle&=x
handle&=rows
handle&=columns
handle&=1
return handle
end function

global procedure flip_matrix_x(sequence handle)
sequence q
atom k
k=0
if handle[ZAXIS]=1 then
q=define_2d_matrix(handle[XAXIS],handle[YAXIS])
for i=handle[XAXIS]-1 to 0 by -1 do
for j=0 to handle[YAXIS]-1 do
poke(q[1]+i*handle[XAXIS]+j,peek(handle[1]+k*handle[XAXIS]+j))
end for
k+=1
end for
swap_blocks({handle[1],handle[1]+(handle[2]*handle[3]*handle[4])-1},{q[1],q[1]+(q[2]*q[3]*q[4])-1})
free(q[1])
end if
end procedure

global procedure flip_matrix_y(sequence handle)
sequence q
atom k
k=0
if handle[ZAXIS]=1 then
q=define_2d_matrix(handle[XAXIS],handle[YAXIS])
for i=handle[YAXIS]-1 to 0 by -1 do
for j=0 to handle[XAXIS]-1 do
poke(q[1]+j*handle[XAXIS]+i,peek(handle[1]+j*handle[XAXIS]+k))
end for
k+=1
end for
swap_blocks({handle[1],handle[1]+(handle[2]*handle[3]*handle[4])-1},{q[1],q[1]+(q[2]*q[3]*q[4])-1})
free(q[1])
end if
end procedure

global procedure break_right_col(sequence handle)
sequence q
q=define_2d_matrix(handle[2],handle[3])
clear_mem(q[1],q[1]+q[2]*q[3]-1)
--Break last column and store in temp zone
for i=0 to handle[XAXIS]-1 do
poke(q[1]+i*handle[XAXIS],peek(handle[POINT]+i*handle[XAXIS]+handle[YAXIS]-1))
end for
--Copy the rest of the matrix to the temp
for i=0 to handle[YAXIS]-2 do
for j=0 to handle[XAXIS] do
poke(q[1]+j*handle[XAXIS]+i+1,peek(handle[1]+j*handle[XAXIS]+i))
end for
end for
swap_blocks({q[1],q[1]+q[2]*q[3]-1},{handle[1],handle[1]+handle[2]*handle[3]-1})
free(q[1])
end procedure

global procedure break_left_col(sequence handle)
sequence q
q=define_2d_matrix(handle[2],handle[3])
clear_mem(q[1],q[1]+q[2]*q[3]-1)
--Break first column and store in last column of temp zone
for i=0 to handle[XAXIS]-1 do
poke(q[1]+i*handle[XAXIS]+handle[YAXIS]-1,peek(handle[1]+i*handle[XAXIS]))
end for
--Copy the rest of the matrix
for i=0 to handle[YAXIS]-2 do
for j=0 to handle[XAXIS]-1 do
poke(q[1]+j*handle[XAXIS]+i,peek(handle[1]+j*handle[XAXIS]+i+1))
end for
end for
swap_blocks({q[1],q[1]+q[2]*q[3]-1},{handle[1],handle[1]+handle[2]*handle[3]-1})
free(q[1])
end procedure

global procedure break_top_row(sequence handle)
sequence q
q=define_2d_matrix(handle[2],handle[3])
clear_mem(q[1],q[1]+q[2]*q[3]-1)
--Break top row and place in bottom
for i= 0 to handle[YAXIS]-1 do
poke(q[1]+q[XAXIS]*(q[XAXIS]-1)+i,peek(handle[1]+i))
end for
--Copy the rest of the matrix
for i=1 to handle[XAXIS]-1 do
for j=0 to handle[YAXIS]-1 do
poke(q[1]+(i-1)*handle[XAXIS]+j,peek(handle[1]+i*handle[XAXIS]+j))
end for
end for
swap_blocks({q[1],q[1]+q[2]*q[3]-1},{handle[1],handle[1]+handle[2]*handle[3]-1})
free(q[1])
end procedure

global procedure break_bottom_row(sequence handle)
sequence q
q=define_2d_matrix(handle[2],handle[3])
clear_mem(q[1],q[1]+q[2]*q[3]-1)
--Break bottom row ad put on top
for i=0 to handle[YAXIS]-1 do
poke(q[1]+i,peek(handle[1]+handle[XAXIS]*(handle[XAXIS]-1)+i))
end for
--Copy the rest of the matrix
for i=0 to handle[XAXIS]-2 do
for j=0 to handle[YAXIS]-1 do
poke(q[1]+(i+1)*q[XAXIS]+j,peek(handle[1]+i*handle[XAXIS]+j))
end for
end for
swap_blocks({q[1],q[1]+q[2]*q[3]-1},{handle[1],handle[1]+handle[2]*handle[3]-1})
free(q[1])
end procedure