include machine.e
include mod.e
include rwd.e
include get.e

sequence message
object xbase,inkey

function makeseed1(sequence data,atom base)
atom out
out=0
for i=1 to length(data) do
out+=modulus2(data[i]*modulus2(data[i],modulus2(data[i],length(data),1),1),base*base,1)
end for
return out
end function

function makeseed2(sequence data,atom base)
atom out
out=0
for i=2 to length(data) do
out+=floor(data[i]/(1+modulus2(data[i],length(data),1)))
out/=modulus2(base/(1+modulus2(data[i-1],length(data),1)),length(data),1)
end for
for i=length(data) to 2 do
out+=xor_bits(data[i],data[i-1])
out-=xor_bits(data[(length(data)-i)+1],data[i])
end for
out=floor(out)
return out
end function

function makeseed3(sequence data, atom base)
atom out
out=0
for i=1 to base by 3 do
for j=1 to length(data) do
out+=floor(data[j]/i)
out*=floor(data[(length(data)-j)+1]/(i))
end for
end for
for i=1 to base by 2 do
out=floor(sqrt(out))
end for
return out
end function

function makeseed4(sequence data, atom base)
atom out
out=0
for i=1 to length(data) do
out=xor_bits(xor_bits(data[i],base),out)
end for
return out
end function

puts(1,"Seed generator examples\nBy: Flaming Rain Software\n\n")
puts(1,"INFO: Accepts data and a base number and generates seeds based on them.\n")
puts(1,"\n1) Test\n")
inkey=wait_key()

clear_screen()
puts(1,"Enter a message:\n")
message=read_key(0,2)
puts(1,"\n\nEnter a base\n")
xbase=get(0)
xbase=xbase[2]
printf(1,"\n\nmakeseed1(): %d",makeseed1(message,xbase))
printf(1,"\nmakeseed2(): %d",makeseed2(message,xbase))
printf(1,"\nmakesees3(): %d",makeseed3(message,xbase))
printf(1,"\nmakeseed4(): %d",makeseed4(message,xbase))