include mem.e
include get.e
include rwd.e
include string.e

object inkey
integer id1,id2, mode
sequence mem1,mem2,filename,key
integer size

size=3

puts(1,"Example stream cipher: model 2\n")
puts(1,"By: Flaming Rain Software\n\n")
puts(1,"INFO: This program generates a key file file to be processed with the original\ndata. This type of cipher is known as a one-time pad and is unbreakable if the\nkey is kept secret.\n\n")
puts(1,"1) Encryption\n2) Decryption\n\n")

inkey=wait_key()

if inkey='1' then
inkey=0
clear_screen()
--Get names of files involved
puts(1,"Enter the name of the file to be encrypted:\n")
filename=read_key(0,2)
clear_screen()
puts(1,"Would you like to create a new key file, or use an existing one?\n")
puts(1,"1) Create new\n2) Use existing\n")
inkey=wait_key()
clear_screen()
if inkey='1' then
mode=1
puts(1,"Enter the name of the file to store the key in:\n")
key=read_key(0,2)
end if
if inkey='2' then
mode=2
puts(1,"Enter the name of an existing file to use as a key:\n")
key=read_key(0,2)
end if
inkey=0
--Open files specified
id1=open(filename,"rb")
--Construct memory blocks for data file
mem1=file_to_mem(id1,0,size)

if mode=1 then
id2=open(key,"wb")
--Construct memory blocks for key file
mem2=repeat(0,length(mem1))
for i=1 to length(mem1) do
mem2[i]=allocate(size)
end for
for i=1 to length(mem2) do
for j=0 to size-1 do
poke(mem2[i]+j,rand(256)-1)
end for
end for

--Write key data to key file
mem_to_file(id2,mem2,size,0,1)
close(id2)
end if

if mode=2 then
id2=open(key,"rb")
mem2=file_to_mem(id2,0,size)
if file_length(id2)<file_length(id1) then
clear_screen()
puts(1,"Key file is not of sufficient length for encryption!")
mode=-1
end if
close(id2)
end if

--Encrypt data
if mode!=-1 then
for i=1 to length(mem1) do
xor_blocks({mem1[i],mem1[i]+size-1},{mem2[i],mem2[i]+size-1})
end for

--Swap mode of data file for writing
close(id1)
id1=open(filename,"wb")

--Write encrypted data to data file
mem_to_file(id1,mem1,size,0,1)

--Free memory used for encryption
clear_screen()
puts(1,"Key stored in file: "&key)
end if
free_file_mem(mem1)
free_file_mem(mem2)
end if

if inkey='2' then
inkey=0
clear_screen()

--Get file names
puts(1,"Enter name of file to decrypt:\n")
filename=read_key(0,2)
clear_screen()
puts(1,"Enter name of key file:\n")
key=read_key(0,2)
clear_screen()

--Open files
id1=open(filename,"rb")
id2=open(key,"rb")

--Load data and key into memory
mem1=file_to_mem(id1,0,size)
mem2=file_to_mem(id2,0,size)

--Decrypt data
for i=1 to length(mem1) do
xor_blocks({mem1[i],mem1[i]+size-1},{mem2[i],mem2[i]+size-1})
end for

--Swap modes and write decrypted data
close(id1)
close(id2)
id1=open(filename,"wb")
mem_to_file(id1,mem1,size,0,-1)
close(id1)

clear_screen()
puts(1,"Would you like to erase the key data?\n")
puts(1,"1) Erase\n2) Don't erase\n")
inkey=wait_key()
if inkey='1' then
inkey=0
id2=open(key,"wb")
close(id2)
end if
if inkey='2' then
inkey=0
end if

--Free allocated memory
free_file_mem(mem1)
free_file_mem(mem2)
clear_screen()
puts(1,"File decrypted.")
end if